/*
  This file is under public domain.
*/

/*
  Tiny UTF16 to ANSI converter
  using WideCharToMultiByte Windows API.
 */

#include <windows.h>
#include <stdlib.h>

#include "miniMBString.h"

miniMBString::miniMBString(LPCWSTR c) : m_string(0) {
	static const DWORD flags = WC_COMPOSITECHECK;
	static const UINT cp = CP_ACP;
	
	if (c) {
		int length = WideCharToMultiByte(cp, flags, c, -1, NULL, 0, NULL, NULL);
		if (length > 0) {
			m_string = (char *) malloc(length);
			if (m_string) {
				m_string[0] = '\0';
				WideCharToMultiByte(cp, flags, c, -1, m_string, length, NULL, NULL);
			}
		}
	}
}
