/*
  This file is under public domain.
*/
#include <windows.h>
#include <tchar.h>

#include <stdlib.h>
#include <string.h>

#include "utils.h"


TCHAR *next_line(TCHAR **lines, TCHAR **buffer, size_t *length)
{
	TCHAR *p;
	size_t i;
	
	p = _tcspbrk(*lines, _T("\r\n"));
	if (p == NULL) {
		p = *lines;
		*lines = NULL;
		return p;
	}
	i = p - *lines + 1;
	if (*length < i) {
		free(*buffer);
		TCHAR *b = (TCHAR *) malloc(i * sizeof(TCHAR));
		if (b == NULL) return NULL;
		*buffer = b;
		*length = i;
	}
	memcpy(*buffer, *lines, i * sizeof(TCHAR));
	(*buffer)[i - 1] = _T('\0');
	*lines = p + ((p[0] == _T('\r') && p[1] == _T('\n')) ? 2 : 1);
	return *buffer;
}


TCHAR *ul_to_as(ULONG num)
{
	TCHAR *buffer;
	ULONG n;
	int i;
	
	if (num > 0) {
		for (n = num, i = 0; n > 0; n /= 10, i ++)
			;
	} else {
		i = 1;
	}
	buffer = (TCHAR *) malloc((i + 1) * sizeof(TCHAR));
	if (buffer == NULL) return NULL;
	buffer[i] = _T('\0');
	do {
		buffer[-- i] = _T('0') + num % 10;
	} while ((num /= 10) > 0);
	return buffer;
}
