/*
  This file is under public domain.
*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

char *utils_regread(char *key)
{
	const struct { HKEY hKey; char *name; } root[] = {
		{HKEY_CLASSES_ROOT, "HKCR\\"},
		{HKEY_CURRENT_USER, "HKCU\\"},
		{HKEY_LOCAL_MACHINE, "HKLM\\"},
		{HKEY_USERS, "HKU\\"},
		{HKEY_CURRENT_CONFIG, "HKCC\\"},
		{HKEY_CLASSES_ROOT, "HKEY_CLASSES_ROOT\\"},
		{HKEY_CURRENT_USER, "HKEY_CURRENT_USER\\"},
		{HKEY_LOCAL_MACHINE, "HKEY_LOCAL_MACHINE\\"},
		{HKEY_USERS, "HKEY_USERS\\"},
		{HKEY_CURRENT_CONFIG, "HKEY_CURRENT_CONFIG\\"},
	};
	int i, n;
	HKEY hKey;
	LPBYTE lpData;
	DWORD dwSize = 0, dwType = 0;
	char *ret = NULL, *p;
	
	// determine root key
	for (i = 0; i < 10; i ++) {
		n = strlen(root[i].name);
		if (! strncmp(key, root[i].name, n)) {
			key += n;
			break;
		}
	}
	if (i == 10) {
		return NULL;
	}
	// extract value name
	p = key + strlen(key);
	while (p >= key) {
		if (*p -- == '\\' && ! IsDBCSLeadByte(*p)) {
			p ++;
			break;
		}
	}
	*p ++ = '\0';
	// open key
	if (RegOpenKeyEx(root[i].hKey, key, 0, KEY_READ, &hKey) != ERROR_SUCCESS) {
		return NULL;
	}
	// get value
	if (RegQueryValueEx(hKey, p, 0, &dwType, NULL, &dwSize) == ERROR_SUCCESS) {
		if (dwSize > 0) {
			lpData = (LPBYTE) malloc(dwSize);
			if (lpData) {
				if (RegQueryValueEx(hKey, p, 0, &dwType, lpData, &dwSize) == ERROR_SUCCESS) {
					if (dwType == REG_DWORD) {
						ret = (char *) malloc(33);
						if (ret) {
							_itoa(*((LPDWORD) lpData), ret, 10);
						}
						free(lpData);
					} else {
						ret = (char *) lpData;
					}
				}
			}
		}
	}
	RegCloseKey(hKey);
	return ret;
}
