/*
  This file is under public domain.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "utils_string.h"

static int isescape(const char c)
{
	if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') ||
		(c >= '0' && c <= '9') || c == '_' || c == '.' || c == '-') {
		return 0;
	} else if (c == ' ') {
		return -1;
	} else {
		return 1;
	}
}

char *utils_urlescape(char *s)
{
	char *p, *pp;
	size_t n = 0;
	char b[3];
	
	if (s == NULL || *s == '\0') {
		return NULL;
	}
	for (p = s; *p != '\0'; p ++) {
		n += (isescape(*p) > 0) ? 3 : 1;
	}
	p = pp = (char *) malloc(sizeof(char) * (n + 1));
	if (! p) {
		return NULL;
	}
	for (; *s != '\0'; s ++) {
		switch (isescape(*s)) {
		case -1:
			*pp ++ = '+';
			break;
		case 0:
			*pp ++ = *s;
			break;
		case 1:
			sprintf(b, "%02X", (unsigned char) *s);
			*pp ++ = '%';
			*pp ++ = b[0];
			*pp ++ = b[1];
			break;
		}
	}
	*pp ++ = '\0';
	return p;
}
